package ovh.gasser.newshapes.ui.menu;

import ovh.gasser.newshapes.attributes.ColorAttributes;
import ovh.gasser.newshapes.attributes.SelectionAttributes;
import ovh.gasser.newshapes.shapes.SCircle;
import ovh.gasser.newshapes.shapes.SCollection;
import ovh.gasser.newshapes.shapes.SRectangle;
import ovh.gasser.newshapes.shapes.Shape;
import ovh.gasser.newshapes.ui.ShapesView;

import java.awt.Color;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class MenuAddListener implements ActionListener {
	private final String shape;
	private final ShapesView view;
	private final SCollection model;

	public MenuAddListener(String shape, SCollection model, ShapesView view) {
		this.shape = shape;
		this.model = model;
		this.view = view;
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		Shape s;
		Rectangle bounds = model.getBounds();
		// All new shapes will be in the center of the panel.
		Point loc = new Point((int)bounds.getCenterX(), (int)bounds.getCenterY());
		
		if (this.shape.equals("SRectangle")){
			s = SRectangle.create(loc.x, loc.y, 50, 50);
		} else if (this.shape.equals("SCircle")){
			s = SCircle.create(loc.x, loc.y, 50);
		} else return;
		
		s.addAttributes(new SelectionAttributes());
		s.addAttributes(new ColorAttributes(true, false, randomColor(), Color.BLACK));
		model.add(s);
		view.repaint();
	}
	
	private Color randomColor(){
		return new Color((int)(Math.random() * 0x1000000));
	}
}
